datablock AudioProfile(sgrings)
{
   volume   = 1.0;
   filename    = "~/data/sound/sgsound/sg_rings.wav";
   description = AudioClosest3d;
   preload = true;
};

function ringsound(%brick) { 
%pos=%brick.getposition();
%sfx1 = new AudioEmitter() { 
position = vectorAdd(%pos,"2.5 2.5 1"); 
rotation = "1 0 0 0"; 
scale = "1 1 1"; 
useProfileDescription = "0"; 
fileName = "~/data/sound/sgsound/sg_rings.wav"; 
type = "2"; 
volume = "0.6"; 
outsideAmbient = "1"; 
referenceDistance = $sgref; 
maxDistance = $sgmax; 
isLooping = "0"; 
is3D = "1"; 
loopCount = "-1"; 
minLoopGap = "0"; 
maxLoopGap = "0"; 
coneInsideAngle = "360"; 
coneOutsideAngle = "360"; 
coneVector = "0 1 0"; 
minDistance = "10.0"; 
}; 
schedule(8000,0,"kawooshdelete",%sfx1);

}


//==============================
//sg rings======================
//==============================
function movebrick(%brick,%height,%time)
{
%steps=10;
//%Z = ((3*getWord(%XYZ,2))*0.2) / (%mover.Steps);
//		%CurTrans = %mover.getTransform();
//		%CurZ = getword(%CurTrans,2);		
//		%newTrans = %newX SPC %newY SPC %newZ SPC eulerToQuat(%NewRotX SPC %NewRotY SPC %NewRotZ);
//		%mover.setTransform(%newTrans);
if(!isObject(%brick))
	return;
%trans = %brick.getTransform();
%x=getword(%trans,0);
%y=getword(%trans,1);
%z=getword(%trans,2);
////echo(%height);
////echo(%time);
%delta=%height/(%steps);//*%time);
////echo(%delta);
%z=%z+%delta;
%trans=(%x SPC %y SPC %z);
%height=%height-%delta;
%time=%time-%steps;

if(%time<0){
	////echo("rum!");
	return;
}
schedule(%steps,0,"movebrick",%brick,%height,%time);
if(!isObject(%brick))
	return;
%brick.setTransform(%trans);
}


function callrings(%r1,%r2)
{
if(%r1==%r2)
	return;

	for(%t =0; %t < MissionCleanup.getCount(); %t++)
	{
		////echo("current T is " @ %t);
		%rid = MissionCleanup.getObject(%t);
		if(%rid.ringsid == %r1)
		{
			////echo("real ringsoridin is " @ %rid);
			%fptrue = 1;
			////echo("because of " @ %r1 @ " = " @ %rid.ringsid @ " !");
			%r1id = %rid;
			break;
			//echo("test");
		}
		//if(%fptrue = 0){return;}		
	}	
	for(%t =0; %t < MissionCleanup.getCount(); %t++)
	{
		////echo("current T is " @ %t);
		%rid = MissionCleanup.getObject(%t);
		if(%rid.ringsid == %r2)
		{
			////echo("real ringstarget is " @ %rid);
			%fptrue = 1;
			////echo("because of " @ %r2 @ " = " @ %rid.ringsid @ " !");
			%r2id = %rid;
			break;
		}
		//if(%fptrue = 0){return;}		
	}	
	if(%r1id.inuse || %r2id.inuse)
	return;
	%r1id.inuse=1;
	%r2id.inuse=1;
	%r1id.setskinname("darkgray");
	%r2id.setskinname("darkgray");
	//Bricks gefunden - Ringe machen!
if(!isObject(%r1id))
{
	////echo("erro1r");
	return;
	}
	if (!isObject(%r2id))
	return;
	
	sgringani(%r1id);
	sgringani(%r2id);
	schedule(2000,0,"scanringstele",%r1id,%r2id);


}

function sgringani(%brick)
{
//echo("sgringani");
//echo(%brick);
if(!isObject(%brick))
	return;
	
ringsound(%brick);
	%a=sgringmake(%brick);
	%b=sgringmake(%brick);
	%c=sgringmake(%brick);
	%d=sgringmake(%brick);
	%e=sgringmake(%brick);
	
%wait=300;
%height=2.5;
%spalt=0.5;
%wielange=1700;
%wait=%wielange/4;
movebrick(%a,%height,%wielange);
schedule(%wait*1,0,"movebrick",%b,%height-%spalt*1,%wielange);
schedule(%wait*2,0,"movebrick",%c,%height-%spalt*2,%wielange);
schedule(%wait*3,0,"movebrick",%d,%height-%spalt*3,%wielange);
schedule(%wait*4,0,"movebrick",%e,%height-%spalt*4,%wielange);
schedule(5000-%wielange,0,"sgringani2",%a,%b,%c,%d,%e,%brick);
schedule(%wait*5-50,0,"mango",%brick);

}

function mango(%brick)
{
//echo("mangos");
%brick=sgringmake2(%brick);
schedule(0,0,"movebrick",%brick);
%start=0;
%wielange=600;
schedule(%start,0,"movebrick",%brick,2.6,%wielange);
schedule(%start+100+%wielange,0,"deletebrick1",%brick);
}

function sgringani2(%a,%b,%c,%d,%e,%brick)
{
%wait=300;
%height=-0.85;//-2.5
%spalt=0.5;
%wielange=1200;//1700
%wait=%wielange/4;
movebrick(%e,%height,%wielange);
schedule(%wait*1,0,"movebrick",%d,%height-%spalt*1,%wielange);
schedule(%wait*2,0,"movebrick",%c,%height-%spalt*2,%wielange);
schedule(%wait*3,0,"movebrick",%b,%height-%spalt*3,%wielange);
schedule(%wait*4,0,"movebrick",%a,%height-%spalt*4,%wielange);
schedule(%wielange+1000,0,"deletebrick",%a,%b,%c,%d,%e,%brick);
}	
function deletebrick(%a,%b,%c,%d,%e,%brick)
{
%brick.inuse=0;
%a.delete();
%b.delete();
%c.delete();
%d.delete();
%e.delete();
}
function deletebrick1(%a)
{
%a.delete();
}
function sgringmake(%brick)
{
		%pos=%brick.getposition();
		%b=new staticshape()
		{
            position=%pos;
            rotation="1 0 0 0";
            scale="4.9 4.9 0.9";
            datablock=statictile2x2round;
			sg=1;
        };
		MissionCleanUp.add(%b);
        %b.setskinname("graydark");
		return %b;
}
function sgringmake2(%brick)
{
		%pos=%brick.getposition();
		%b=new staticshape()
		{
            position=%pos;
            rotation="1 0 0 0";
            scale=VectorScale("4.9 4.9 0.9",2);
            datablock=staticcylinder1x1ft;
			sg=1;
        };
		MissionCleanUp.add(%b);
        %b.setskinname("yellow");
		return %b;
}
function scanringstele(%r1,%r2)
{	
	//echo("scanringstele1");
	//scanringstele1(%r1,%r2);
	schedule(10,0,"scanringstele1",%r1,%r2);
	%pos1=%r1.getposition();
	%pos2=%r2.getposition();
	%radius=1;
	InitContainerRadiusSearch(vectorAdd(%r1.getposition(),"2.5 2.5 2"), %radius, $TypeMasks::PlayerObjectType);
	//echo("search1");
	//%obj = firstWord(%string = containerSearchNext());
  	while ((%targetObject = containerSearchNext()) != 0)
   	{
		//echo("used1?");
		//echo(%targetObject.usedrings);
		if(!%targetObject.usedrings){
		%targetObject.setWhiteout(0.7);
		////echo("scanringstele1while");
		%dist = containerSearchCurrRadiusDist();
		////echo("scanringstele1nachdist");
		////echo("found vehicle:" SPC %targetObject SPC ",distance is:" SPC %dist);
		%targetobject.startFade(300,50,0);
		%targetObject.setTransform(vectorAdd(%pos2,"2.5 2.5 0.6"));
		%targetObject.usedrings=1;
		schedule(1000,0,"resetusage",%targetObject);
		}else{
						//echo("i have used rings b4 1");
		}
   	} 
}

function resetusage(%player)
{
//echo("reseted");
//echo(%player);
%player.usedrings=0;
}


function scanringstele1(%r1,%r2)
{
	////echo("scanringstele2");
	%pos2=%r2.getposition();
	%radius=1;
	InitContainerRadiusSearch(vectorAdd(%pos2,"2.5 2.5 2"), %radius, $TypeMasks::PlayerObjectType);
	////echo("search2");
	//%obj = firstWord(%string = containerSearchNext());
  	while ((%targetObjecta = containerSearchNext()) != 0)
   	{
		//echo("used2?");
		//echo(%targetObjecta.usedrings);
		if(!%targetObjecta.usedrings){
		%targetObjecta.setWhiteout(0.7);
		////echo("scanringstele2while");
		//%dist = containerSearchCurrRadiusDist();
		////echo("scanringstele22#nachdist");
		////echo("found vehicle:" SPC %targetObjecta SPC ",distance is:" SPC %dist);
		%targetobjecta.startFade(300,50,0);
		%posa=%r1.getposition();
		%targetObjecta.setTransform(vectorAdd(%r1.getposition(),"2.5 2.5 0.6"));
		%targetObjecta.usedrings=1;
		schedule(1000,0,"resetusage",%targetObjecta);
		}else{
						//echo("i have used rings b4 2");
		}
   	}

}

function nearestrings(%id)
{
if(!isObject(%id))
	return;
	%sg=0;
%pos=%id.gettransform;
InitContainerRadiusSearch(%id.getTransform(), 20, $TypeMasks::ShapeBaseObjectType);
   while ((%targetObject = containerSearchNext()) != 0) 
   {
	//if(%targetObject.sg)
	//{
		////echo("sg1!");
		////echo(%targetObject);
		if(!%targetObject.ringsid ==0)
		{
		%rings=%targetObject;
		break;
		}
	//}
   }
   return(%rings);

}