//===========SGPARTICLES===========

datablock AudioProfile(beamSound)
{
   filename    = "~/data/sound/vehicles/legoatv/engine_idle.wav";
   description = AudioClose3d;
   preload = true;
};


//=======ENHANCED SG FUNCTIONS======

function nearestenergysource(%brick)
{
	if(!isObject(%brick))
		return 0;
	%Energy=0;
	InitContainerRadiusSearch(%brick.getTransform(), 30, $TypeMasks::ShapeBaseObjectType);
	while ((%targetObject = containerSearchNext()) != 0) 
	{
		if(%targetObject.isEnergySource && %targetObject.Energy>0)
		{
			%energy=%energy+%targetObject.energy;
			%source=%targetObject;
		}
	}
	%brick.nearestenergy=%energy;
	return %source;
}

function nearestdhd(%brick)
{
	if(!isObject(%brick))
		return;
		
	%targetObject=0;
	InitContainerRadiusSearch(%brick.getTransform(), 30, $TypeMasks::ShapeBaseObjectType);
	while ((%targetObject = containerSearchNext()) != 0) 
	{
		if(%targetObject.isDHD)
		{
			break;
		}
	}
	return %targetObject;
}
function checksgenergy(%client,%sg)
{
	if(!isObject(%sg))
		return;
	%dhd=nearestdhd(%sg);
	if(isObject(%dhd))
	{
		//no problems! dhds have unlimited energy (for now)
		return 1;
	}
	%other=nearestenergysource(%sg);
	%othere=%sg.nearestenergy;
	//echo("othere"@%othere);
	if(!isObject(%other))
	{
		messageclient(%client,"","No energy supply! Dialing aborted!");
		return 0;
	}
	if(%othere<10)
	{
		messageclient(%client,"","Not enough energy! Dialing aborted!");
		return 0;
	}
	//%other.energy=%other.energy-10;
	return 1;
}

function disablesg(){
//empty loel
}
function servercmdlistsg(%client)
{
	messageclient(%client,"","List of Ids:");
	%i=0;
	for(%t =0; %t < MissionCleanup.getCount(); %t++)
	{
		%brick = MissionCleanup.getObject(%t);
		if(%brick.AD)
		{
		%i++;
		//echo(%i@" AD:"@%brick.AD@" Brickid: "@%brick);
		messageclient(%client,"",%i@" AD:"@%brick.AD);
		}
		//if(%fptrue = 0){return;}
	}	
}

function listsg()
{
%i=0;
	for(%t =0; %t < MissionCleanup.getCount(); %t++)
	{
		%brick = MissionCleanup.getObject(%t);
		if(%brick.AD)
		{
		%i++;
		echo(%i@" AD:"@%brick.AD@" Brickid: "@%brick);
		}
		//if(%fptrue = 0){return;}
	}	
}

function serverCmdrandom(%client)
{
	//echo(nearestsg(%client.player));
	%origin=nearestsg(%client.player);
	%i=0;
	for(%t =0; %t < MissionCleanup.getCount(); %t++)
	{
		%brick = MissionCleanup.getObject(%t);
		if(%brick.AD)
		{
		%sgs[%i]=%brick.AD;
		echo(%i@" AD:"@%brick.AD);
		%i++;
		}
		//if(%fptrue = 0){return;}
	}	
	//echo(%sgs.getCount());
	%r=getRandom(0,%i);
	if(%sgs[%r]==%origin.ad)
		%r=%r+1;
	if(%r>%i)
		%r=$r-2;
		
	dial(%origin.ad,%sgs[%r]);
	
}

function serverCmdMakeIris(%client){



}
function serverCmdclose(%client)
{
	//%mysg.isdialing=0;
	%mysg=nearestsg(%client.player);
	if(!%mysg.status)
		return;
	%othersg=%mysg.connected;
	%mysg.timer=0;
	%othersg.timer=0;
}
function stargatecountdown(%bz,%be,%sg)
{
if(!%sg || !%bz || !%be)
	return;
	//19160 19158 stargatecountdown(19160,19158,2954);
if(!%sg.status)
	%time=0;
%time=%sg.timer;
%z=mfloor(%time/10);
%e=%time-%z*10;
%bz.setskinname("letter"@%z);
%be.setskinname("letter"@%e);
%bz.setshapename("");
%be.setshapename("");
schedule(500,0,"stargatecountdown",%bz,%be,%sg);


}
//=======================
//SG WEAPON==============
//=======================
function countdownrad(%brickid,%cur,%client)
{
//echo(%brickid);
//echo(%cur);
if(!%brickid)
	return;
	
if(%cur>-1){
//echo(%cur);
	%brickid.setshapename("Weapon fired by: "@%client.namebase);
	%skin="letter"@%cur;
	%brickid.setskinname(%skin);
	%cur--;
	schedule(1000,0,"countdownrad",%brickid,%cur,%client);
	}
	else{
	echo("done");
	}
}
function SGRadiation1(%client,%brick){
//echo("sgrad1");

echo("player:"@%client.name);
%mysg=nearestsg(%client.player);
	if(!%mysg.status)
		return;
	%othersg=%mysg.connected;
	%time=8;
	//echo("mysg:"@%mysg);
	//echo("other"@%othersg);
	//%mysg.timer=90;
	
	schedule(1000*%time,0,"SGRadiation2",%client,%mysg,%othersg,%brick);
	countdownrad(13467,%time,%client);
	superdeathlydeployer(%brick,%time*1000);
	%brick.isfiring=1;

}

function superdeathlydeployer(%id,%time)
{
	if(!isObject(%id)){
	echo("not an obj");
		return 0;}
echo(%id SPC %time);
%pos=%id.gettransform;
InitContainerRadiusSearch(%id.getTransform(), 30, $TypeMasks::ShapeBaseObjectType);
   while ((%targetObject = containerSearchNext()) != 0) 
	{
		if(%targetObject.isdeathly)
		{
		echo("FOUND"@%targetobject);
		
	  %p = new ParticleEmitterNode() {
      position = vectoradd(%targetObject.getPosition(),"2 2 0");
      rotation = "1 0 0 0";
      scale = "1 1 1";
      dataBlock = "bombParticleEmitterNode";
      emitter = "FireParticleEmitter";
      velocity = "1";
		};
   schedule(%time+2000,0,"deletething",%p);
		}
	}
   

}



function servercmdtestn(%client)
{
%var=%client.player;
echo(%client.player);
echo(%var);
echo(%var.client.name);
echo(%var.player);

messageclient(%client,"","penis:"@%client.name);
}


function SGRadiation2(%client,%mysg,%othersg,%brick)
{
//echo("sgrad2"@%client);
%brick.isfiring=0;
if(!%mysg.status || !%othersg.status){
//echo("mysg"@%mysg.status);
//echo("other"@%othersg.status);
	%brick.isfiring=0;
	messageclient(%client,"","SG has been shutdown before the Weapon could be fired - sequence aborted.");
	return;
}
if(!%mysg.connected == %othersg){
messageclient(%client,"","Wrong connection... ????");
%brick.isfiring=0;
return;
}
%es=nearestenergysource(%brick);
if(%es.energy<80){
	messageclient(%client,"","Atleast 80 Energy are required for the Weapon to be fired - sequence aborted.");
	return;
}
%es.energy=0;
	
	
	%time=30;
	messageAll("","\c3" SPC %client.namebase SPC " has used the Superweapon!");
			InitContainerRadiusSearch(%othersg.getposition(), 150, ($TypeMasks::PlayerObjectType | $TypeMasks::ShapeBaseObjectType));
   			 while ((%targetObject = containerSearchNext()) != 0)
			 {   
				if(!isObject(%targetObject))
					return;
				
			    //echo("toc: "@%targetObject.getClassName());
				//%pos=%targetObject.getPosition();
				//base mover
				if(false){
				%pos=%targetObject.getPosition();
				%pos=vectoradd(%pos,"0 0 -7000");
				%targetObject.setTransform(%pos);
				}
				//weaponpart
				if(true){
					if((%targetObject.getClassName() $= "Player" || %targetObject.getClassName() $= "AIPlayer")&&true)
					{
						%targetObject.kill();
						messageclient(%client,"","You've killed "@%targetObject.client.namebase);
						messageAll("","\c3" SPC %client.namebase SPC "killed" SPC %targetobject.client.namebase);
						messageclient(%targetobject.client,"","You've been killed by a SuperWeapon used by "@%client.namebase);
						%client.incscore(1);
					}
					if(%targetObject.getDatablock().classname $= "Brick" && !%targetObject.sg && true)
					{
						//echo("brick!"@%target.object);
						%targetObject.hits = 0;
						%targetObject.startFade(0, 0, true);
						%targetObject.hide(true);
						%targetObject.setSkinName(%targetObject.SkinName);
						%targetObject.schedule(%time*1000, "hide", false);
						%targetObject.schedule(%time*1000 + 100, "startFade", 1000, 0, false);
						%targetObject.energy=0;
						//%targetObject.delete();
					}
					if(%targetObject.getDatablock().classname $= "Brick" && %targetObject.sg && !%targetObject.status && %targetObject.energy)
					{
						%targetObject.energy=0;
						//%targetObject.delete();
					}
				}
				
			}
			%mysg.noplayer=0;
			//%mysg.timer=9999;
			messageclient(%client,"","\nWeapon has been fired.\nClosing SG now...");
			%brick.isfiring=0;
}
function applyradiation(%client)
{


}



//================== ASGARD BEAMER ====================

function asgardbeam(%obj,%obj1){
if(!isObject(%obj))
	return;
	%pos=%obj1.getPosition();
	%pos=vectoradd(%pos,"0 0 0.5");
	echo(%obj SPC "geht jetzt zu" SPC %pos @"!");
	%time=1200;
	%obj.startFade(%time,0,1);

	%obj.schedule(%time, "startFade", %time, 0, false);
	%obj.schedule(%time, "setTransform",%pos);
	schedule(0,0,"asgardparticle",%obj.getPosition());
	schedule(%time,0,"asgardparticle",%pos);


}


function asgardparticle(%pos){

	  %p = new ParticleEmitterNode() {
      position = vectoradd(%pos,"0 0 0");
      rotation = "1 0 0 0";
      scale = "1 1 1";
      dataBlock = "bombParticleEmitterNode";
      emitter = "FireParticleEmitter";
      velocity = "1";
   };
   schedule(10,0,"deletething",%p);

}

//asgard platform

function asgardplatformplayer(%id,%playername)
{
	
	%username = %playername;

	//%totalchars = strlen(%playername)-(strlen(%username)+4);
	//%usernamelength = 5+strlen(%username);

	%match = 0;
	for(%i = 0; %i<ClientGroup.getCount(); %i++)
	{
		%cl = ClientGroup.getObject(%i);
		if(%cl.namebase $= %username)
		   %match = %cl;
	}
	if(%match !$= 0)
	{
		echo("playerfound!" SPC %match.namebase);
		asgardplatform(%id,vectoradd(%match.player.getposition(),"2 2 0.3"));
	}


}


function asgardplatform(%id,%coords)
{
echo("asgardpl:" SPC %id);
	if(!isObject(%id))
		return 0;
		echo("id:" SPC %id SPC "coords:" SPC %coords);
	%sg=0;
	%size=getword(%id.getscale(),1);
	%fac=%size*0.5;
	//%pos=vectoradd(%id.getposition(),%fac SPC %fac SPC 2*(getword(%id.getscale(),2)));
	%pos=vectoradd(%id.getposition(),"2.5 2.5 2");
	echo(%pos);
	
	%tpos=vectorsub(%coords,"-5 -5 -1");
	%tpos=vectorsub(%coords,"2.5 2.5 -0.1");
	//%tpos=%coords;
	%bew=vectorsub(%tpos,%id.getposition());
	
	%t=0;
	InitContainerRadiusSearch(%pos, 2.5, $TypeMasks::PlayerObjectType | $TypeMasks::ShapeBaseObjectType |  $TypeMasks::VehicleObjectType);
   while ((%targetObject = containerSearchNext()) != 0) 
   {
	if(%targetObject.getClassName() $= "Player" || %targetObject.getClassName() $= "AIPlayer" || %targetObject.getClassName() $="WheeledVehicle" || %targetObject.getClassName() $="Vehicle")
	{
		echo("targetobj would be:" @ %targetObject);
		//asgardparticle(%targetObject.getPosition());
		//asgardbeam2(%targetObject,vectoradd(%targetObject.getposition(),%bew));
		
		//schedule(getRandom(0,500),0,"asgardbeam2",%targetObject,vectoradd(%targetObject.getposition(),%bew));
		//schedule(10000+getRandom(0,500),0,"asgardback",%targetObject,%targetObject.getposition());
		schedule(0,0,"asgardbeam2",%targetObject,vectoradd(%targetObject.getposition(),%bew));
		schedule(10000,0,"asgardback",%targetObject,%targetObject.getposition());
		//schedule(%t*200+getRandom(0,200),0,"asgardbeam2",%targetObject,vectoradd(%targetObject.getposition(),%bew));
		//schedule(%t*200+getRandom(0,200)+10000,0,"asgardback",%targetObject,%targetObject.getposition());
		%t=%t+1;
	}
   }
}

function asgardback(%id,%pos)
{
	asgardbeam2(%id,%pos);

}


function asgardbeam2(%obj,%pos){
if(!isObject(%obj))
	return;
	%pos=vectoradd(%pos,"0 0 0");
	echo(%obj SPC "geht jetzt zu" SPC %pos @"!");
	%time=1200;
	schedule(100,0,"playBeamsound",%obj);
	schedule(%time-100,0,"playBeamsound",%obj);
	schedule(%time-(200),0,"asgardbeamin",%pos);
	schedule(%time-700,0,"asgardbeamout2",%obj);
	//asgardbeamout2(%obj);
	if(!%obj.client.isAdminCloaked){
	%obj.startFade(%time,0,1);
	%obj.schedule(%time, "startFade", %time, 0, false);
	}else{
	echo("obj is admincloaed!");
	}
	
	%obj.schedule(%time, "setTransform",%pos);
	schedule(0,0,"asgardparticle",%obj.getPosition());
	schedule(%time,0,"asgardparticle",%pos);
	freezeobject2(%obj);
	schedule(%time-1,0,"freezeobject2",%obj);
	schedule(%time+1,0,"freezeobject2",%obj);
	schedule(%time*2,0,"freezeobject2",%obj);
	
	//%speichD.schedule(100, "playAudio", 0, DeathCrySound);
}
function playBeamsound(%ob)
{
   //%ob.playAudio(0,beamSound);
}
function asgardbeamout(%id)
{
	%pos=%id.getposition();
	  %p = new ParticleEmitterNode() {
      position = vectoradd(%pos,"0 0 1");
      rotation = "1 0 0 0";
      scale = "1 1 1";
      dataBlock = "bombParticleEmitterNode";
      emitter = "FireParticleEmitter";
      velocity = "1";
   };
   schedule(1200,0,"deletething",%p);
   moveparticle(%p,3,1200);
}
function asgardbeamin(%pos)
{
//%pos=%id.getposition();
%i=getRandom(0,20)*0.1;
%pos=vectoradd(%pos,"0 0" SPC (7.0+%i));

	  		%p = new Projectile()  
			{
			dataBlock = blastProjectile;
			initialVelocity = "0 0 -65";
			initialPosition = %pos;
			sourceObject = 1;
			sourceSlot = 0;
			client = 1;
			lifetime = 0;
  			};
			missionCleanup.add(%p);
}

function asgardbeamout2(%id)
{
%pos=%id.getposition();
%pos=vectoradd(%pos,"0 0 2.7");
	  		%p = new Projectile()  
			{
			dataBlock = blastProjectile;
			initialVelocity = "0 0 50";
			initialPosition = %pos;
			sourceObject = 1;
			sourceSlot = 0;
			client = 1;
			lifetime = 0;
  			};
			missionCleanup.add(%p);
			//%p.lifetime=1;
schedule(200,0,"deletething",%p);
}

function nearestBeamPlatform(%id)
{
	if(!isObject(%id))
		return 0;
	%sg=0;
	%pos=%id.gettransform;
	InitContainerRadiusSearch(%id.getTransform(), 10, $TypeMasks::ShapeBaseObjectType);
   while ((%targetObject = containerSearchNext()) != 0) 
   {
	if(%targetObject.isBeamPlatform)
	{
		%sg=%targetObject;
		break;
	}
   }
   echo("nearestbeamplatvon" SPC %id SPC %sg);
   return(%sg);
}


//%steamObj.position = "100 100 191";
// ...set a new position, which does absolutely nothing, unless...
//%steamObj.setScale(%steamObj.getScale());
// ...we use the setScale() function to reflexively


function moveparticle(%brick,%height,%time)
{
%steps=10;
//%Z = ((3*getWord(%XYZ,2))*0.2) / (%mover.Steps);
//		%CurTrans = %mover.getTransform();
//		%CurZ = getword(%CurTrans,2);		
//		%newTrans = %newX SPC %newY SPC %newZ SPC eulerToQuat(%NewRotX SPC %NewRotY SPC %NewRotZ);
//		%mover.setTransform(%newTrans);
if(!isObject(%brick))
	return;
%trans = %brick.getTransform();
%x=getword(%trans,0);
%y=getword(%trans,1);
%z=getword(%trans,2);
////echo(%height);
////echo(%time);
%delta=%height/(%steps);//*%time);
////echo(%delta);
%z=%z+%delta;
%trans=(%x SPC %y SPC %z);
%height=%height-%delta;
%time=%time-%steps;

if(%time<0){
	////echo("rum!");
	return;
}
schedule(%steps,0,"movebrick",%brick,%height,%time);
if(!isObject(%brick))
	return;
//%brick.setTransform(%trans);
%brick.position=%trans;
%brick.setScale(%brick.getScale());
}


function deletething(%thing){
%thing.delete();
}



//SHIPSTUFF================
function hyperjump(%vehicle,%pos)
{
%vpos=%vehicle.getPosition();
%vel=%vehicle.getVelocity();
%richt=VectorSub( %pos, %vpos );
%fac=600;
%fac=%fac*VectorDist( %vpos , %pos )*1;
%richtmod=vectorscale(VectorNormalize(%richt),%fac);
//%vehicle.applyImpulse(%vpos, %richtmod);

echo("=======JUMP=======");
echo("Vpos:"@%vpos);
echo("richtmod:"@%richtmod);
schedule(1000,0,"jump",%vehicle,%pos,%vel);


}



function jump1(%vehicle,%pos,%vel)
{
%vehicle.settransform(%pos);
%vehicle.setVelocity(%vel);
}

//==========AUTOSAVE======
//time in minutes!
function autosaving(%time){
if(!$autosave)
	return;
echo("autosave!");
savePersistence("autosave");
exec("rtb/server/scripts/ptta/movers.cs");
if(%time<5){
	%time=5;
	echo("time adjusted to "@%time);
	}
if($autosave){
messageAll("MsgPersistence", "\c0Autosaving every" SPC %time SPC "minutes.");
schedule(%time*60000,0,"autosaving","autosave");
}else{
echo("autosaven beendet!");
}

}

function testray(%obj){
%pos=%obj.getposition();
echo(%pos);
echo(containerFindFirst($TypeMasks::PlayerObjectType | $TypeMasks::ShapeBaseObjectType,%pos, 10 , 10 , 10 ));
//InitContainerRadiusSearch(%id.getTransform(), 30, $TypeMasks::PlayerObjectType | $TypeMasks::ShapeBaseObjectType);
   while ((%targetObject = containerFindNext()) != 0) 
   {
   	//if(%targetObject.client !$= "")
   	//{
	//	echo("player!");
	//	echo(%targetObject);
	//}
	if(isObject(%targetObject)){
	echo("Obje:" SPC %targetObject);
	}
   }
}

//AIVEHICLE====
function servercmdmakeaiv(%client){


   %v = new WheeledVehicle() {
      dataBlock = ailegoatv;
      path = "";
   };
   %v.setTransform(%client.player.getPosition());
   
   
   
  }
  
//==================
//malp using legoatv
//==================



function servercmdCreateMalp(%client){
echo("somebody tries to make a malp... "@%client.namebase);
if(isObject(%client.malp)){
	messageclient(%client,'','You can only have one malp!');
	return;
}
%sg=nearestsg(%client.player);
if(!isObject(%sg))
{
	messageclient(%client,'','You have to be near an sg to create a malp!');
	return;
}

   %v = new WheeledVehicle() {
      dataBlock = legoatv;
      path = "";
   };
   //%v.setTransform(%client.player.getPosition());
	%pos=vectorAdd(%sg.getposition(),"10.5 5 4");
	%v.setTransform(%pos SPC eulerToAxis("0 0 90"));
	messageclient(%client,'',"Malp created near "@nearestsg().ad);
	%v.setskinname(%client.player.getskinname());
	%v.setShapename(%client.namebase@"'s Malp");
	%client.malp=%v;
	%v.disablemove=1;
	%v.ismalp=1;

}

function servercmdkillmalp(%client){
//echo(%v);
if(!isObject(%client.malp)){
messageclient(%client,'','You dont have a malp!');
	return;
	}
%client.malp.delete();
messageclient(%client,'','Your malp has been deleted.');
}

function servercmdMalpMission(%client,%to){
//echo(%client);
//echo(%client.malp);
%v=%client.malp;
%malp=%v;
//echo(%v);
if(!%v || !%to || !isObject(%v)){
echo(%v);
echo(%to);
echo(isObject(%v));
messageclient(%client,'','You dont have a malp!');
	return;
	}
%mygate=nearestsg(%malp);
if(%mygate.status || %mygate.isdialing)
	return;
messageclient(%client,'','Malpmission started!');
if(%mygate.status || %mygate.isdialing)
	return;
%malp.disablemove=1;

dial(%mygate.ad,%to);
echo("malp"@%malp);
schedule(9500,0,"malpfindsg",%malp,%client);
echo("scheded");
}
  
  
 function malpfindsg(%malp,%client){
 //echo("malpfindsg!");
 //if(!%malp || !%isObject(%malp)){return;}
	
%malp.disablemove=1;
//echo("findsg!!malp");
%gate=nearestsg(%malp);
if(!%gate.status)
	return;
//echo("calss"@%malp.getClassname());
%gatep=%gate.getposition();

malpcheckifthere(%malp,%malp.getposition(),%gate,%client);
}
  
  
  function malpcheckifthere(%malp,%oldpos,%gate,%client){
  //function checkifthere(%bot,%oldpos,%gate){
if(!%malp || !isObject(%malp))
	return;

%pos=%malp.getposition();
if(vectordist(%pos,%oldpos)<40){
//echo("not reached");
%gate=nearestsg(%malp);
if(!%gate.status)
	return;
//%target=vectoradd(%gate.getposition(),"1 5 1");
//%bot.setMoveDestination( %target );
vehicledo(%malp,9,1);
schedule(100,0,"malpcheckifthere",%malp,%oldpos,%gate,%client);
}else{
vehicledo(%malp,400,-1);
 %malp.setTransform(setWord(%pos,2,getWord(%pos,2)+(2)));
//%gate.timer=0;
echo("reached!");
%x=getrandom(4,8);
%y=getrandom(-2,2);
%z=-1;
//echo("client."@%client);
schedule(4000,0,"malpwatch",%malp,6000);
//%target=vectoradd(%bot.getPosition(),%x SPC %y SPC %z);
//%bot.setMoveDestination(%target);
//%bot.setAimLocation(%target);
}
}


function servercmdMalpview(%client,%time){
if(%malp.isinviewmode)
	return;
malpwatch(%client,%time);
%malp.isinviewmode=1;
}
function malpwatch(%client,%time){
%malp=%client.malp;
if(%malp.isinviewmode)
	return;
if(isObject(%malp)){
      %client.camera.setTransform(%malp.getEyeTransform());
      %client.camera.setVelocity("0 0 0");
	  %client.setControlObject(%malp);
schedule(%time,0,"endmalpwatch",%malp,%client);
 messageclient(%client,'','Lauchned malp watch');
}else{
messageclient(%client,'','Lost contact to the malp..');
}
}

function endmalpwatch(%malp,%client){
	    echo(returning);
		%malp.isinviewmode=0;
	    %client.setControlObject(%client.player);
	    //%them.setcontrolobject(%col);
	    //%them.camera.setFlyMode();
	    messageclient(%client,'','End malp watch');
		//%malp.delete();
}
  
  
  function vehicledo(%v,%t,%fac){
  
  //%v.setvelocity(%vel);
  if(%fac==1){%rot=eulerToAxis(("0 0 90"));}else{%rot=eulerToAxis(("0 0 -90"));}
  %pos=%v.getposition();
  %v.setTransform(setWord(%pos,0,getWord(%pos,0)-(0.02*%fac)) SPC %rot);
  
  //echo("v:" SPC %v.getVelocity());
  %t--;
  if(%t>0)
  schedule(10,0,"vehicledo",%v,%t,%fac);
 // %v.setMoveDestination(%client.player.getposition());
 // echo("pos"SPC@client.player.getposition());
  }
  
  function testoo(){
 %Logfile = new FileObject();
%Logfile.openForAppend("rtb/test.txt");
%Logfile.writeLine(echo(dumpconsoleclasses()));
//$Logfile.writeLine("Name: "@%victim.namebase @ " ip: "@getrawip(%victim)@" Time: " @ $Sim::Time@ " by: "@%client.namebase);
%Logfile.close();
  
  }
 //ENERGY
 
 function generateEnergy()
 {
 if(!$GenerateEnergy)
	return;
	
//echo("energy isrunniN!");
 //$EnergyZones[$TotalEnergySources++] = %brick;
 //for (%i = 0; %i < MissionCleanup.getCount(); %i++)
 //echo("energy!");
 for (%i = 0; %i < $TotalEnergySources+1; %i++)
 {
	%es=$EnergySources[%i];
	//echo("es:"@%es);
	if(isObject(%es))
	{
		//echo("es"@%es);
		if(%es.isEnergysource && %es.energy<100)
		{
			%es.energy=%es.energy+%es.energyfactor*3;
			%es.setshapename("Energy: "@%es.energy);
		}
	}
 }
 schedule(1000,0,"generateEnergy");
 }
  $generateenergy=1;
  generateenergy();
  //==========
  //===IRIS===
  //==========
  function soundtransformausschlachten(%id)
{
		%eulerRotSG = axisToEuler(getWords(%id.getTransform(),3,6));
		%sgzrot=(getWord(%eulerRotSG,2));
		%dir0 = %sgzrot;
		%dir02=mDegToRad(%dir0);
		%cdir0=mfloor(mcos(%dir02)*100)/100;
		%sdir0=mfloor(msin(%dir02)*100)/100;
		%pos=%id.getposition();
		%rot="90 90" SPC %sgzrot-180;
		%axis=eulerToAxis(%rot);
		%b=0;
		%c=0;
		%x=-(-1*%c*%cdir0+%b*%sdir0);
		%y=(%b*%cdir0+%c*%sdir0);
		%ra=getrandom(0,2)/10;
		%z=4+%ra;
		%pos=vectoradd(%pos,%x SPC %y SPC %z);//0 2 9
		return %pos;
}

function useirisbutton(%brick)
{
	%sgbrickid=nearestSg(%brick);
	if(!isObject(%sgbrickid))
		return;
	
	switchiris(%sgbrickid);
}
  
function switchiris(%sgbrickid)
{
	if(!isObject(%sgbrickid))
		return;
	
	if(%sgbrickid.iris) //iris on
	{
		//delete the iris
		%irisbrick=%sgbrickid.irisbrickid;
		%irisbrick.delete();
		%sgbrickid.iris=0;
		//echo("iris deleted! at" SPC %sgbrickid.ad);
		//echo("iris:" SPC %sgbrickid.iris);
	}
	else
	{
		if(false){
		%eulerRotSG = axisToEuler(getWords(%sgbrickid.getTransform(),3,6));
		%sgzrot=(getWord(%eulerRotSG,2));
		%dir0 = %sgzrot;
		%dir02=mDegToRad(%dir0);
		%cdir0=mfloor(mcos(%dir02)*100)/100;
		%sdir0=mfloor(msin(%dir02)*100)/100;
		%pos=%id.getposition();
		%rot="0 0 0 90 160" SPC %sgzrot-180;
		echo("rot" SPC %rot);
		%axis=eulerToAxis(%rot);
		%b=0.125;
		%c=-5.31006;
		%x=-(-1*%c*%cdir0+%b*%sdir0);
		%z=12.38;
		%y=(%b*%cdir0+%c*%sdir0);
		//%ra=getrandom(0,2)/10;
		//%z=4+%ra;
		%pos=vectoradd(%sgbrickid.getposition(),%x SPC %y SPC %z);}
		
					%eulerRotSG = axisToEuler(getWords(%sgbrickid.getTransform(),3,6));
			%sgzrot=(getWord(%eulerRotSG,2));

			//OPF
			%dir0 = %sgzrot;
			%dir02=mDegToRad(%dir0);
			%cdir0=mfloor(mcos(%dir02)*100)/100;
			%sdir0=mfloor(msin(%dir02)*100)/100;
		//	%posa = vectorAdd(%speicha.getPosition(),%sigateA*$sgvx SPC %cogateA*$sgvy SPC $sgvz-0.2);
		//-90 0 270
		
		%pos=%sgbrickid.getposition();
		%rot="-90 0" SPC %sgzrot+90;//-270;
		//%rot="-90 0 -270";
		echo("eul:" SPC %rot);
		%axis=eulerToAxis(%rot);
		echo("eul:" SPC axistoeuler(%axis));
		//			%vy=(%vy1*%cndir+%vx1*%sndir);
			//%vx=-(-1*%vx1*%cndir+%vy1*%sndir);
		%b=-5;
		%c=-0.15;
		%x=-(-1*%c*%cdir0+%b*%sdir0);
		%y=(%b*%cdir0+%c*%sdir0);
		%z=12.5;
		%pos=vectoradd(%pos,%x SPC %y SPC %z);//0 2 9
		
		
		
		//create an iris
		if(true){
		%irisbrick=new staticshape() 
		{ 
			//position=vectoradd(%pos,"0.0 -1.3 -0.5");//0 -0.5 -0.3 bei 2 2 -.1   0 -1.3 -.5 bei 4 4 -.1
			//position=vectoradd(%sgbrickid.getposition(),"0.125 -5.31006 12.38");
			position=%pos;
			//position=setWord(%obj.getworldboxcenter(),0,getword(%posg,0));
			rotation="0 0 0 1"; 
			scale="10 10 0.00001"; 
			//scale=vectorscale(%size,1);
			datablock=statictile2x2round;
			//datablock=staticcylinder1x1t;
			EulerRot = %rot;
			sg=1;
			dontsave=1;
		};}
		if(false){
		        %irisbrick=new staticshape()
        {
            position="0 0 0";
            rotation="0 0 0 1";
            scale="10 10 0.1";
			eulerrot=%rot;
            datablock=staticcylinder1x1t;
			dontsave=1;
			sg=1;
        };}
		missionCleanup.add(%irisbrick);
		%sgbrickid.iris=1;
		%sgbrickid.irisbrickid=%irisbrick;
		%irisbrick.setTransform(%pos SPC eulerToAxis("-90 0 270"));
		%irisbrick.setTransform(%pos SPC %axis);
		//echo("iris created! at" SPC %sgbrickid.ad);
		//echo("iris:" SPC %sgbrickid.iris);
		//return;
	}
}
//hack an iris

function serverCmdhackiris(%client){
	%nsg=nearestsg(%client.player);
	if(%nsg.isincoming || !%nsg.status)
		return;
		
	%osg=%nsg.connected;
	if(%osg.iris){
		switchiris(%osg);
		echo("Iris opened!");
	}else{
		echo("Iris was open!");
	}
}

function freezeobject2(%obj)
{
	%client=%obj.client;
	if(%client.sitting)
	{
		return;
	}
	
	if(%obj.frozen == 0)
	{
		%obj.frozen = 1;
		%obj.freezeObject = new StaticShape() 
				{
      					position = %obj.getTransform();
      					rotation = "1 0 0 0";
      					scale = "0.001 0.001 0.001";
					dataBlock = "flowers";
 				   			};
		%obj.freezeObject.setcloaked(true);
		%obj.freezeObject.MountObject(%obj,1);
	}	
	else
	{
		%obj.frozen = 0;
		%obj.freezeObject.unMountObject(%objr);
		%obj.freezeObject.delete();
	}
}

function freezeobject(%obj)
{	
%client=%obj.client;
	if(%client.sitting)
	{
		return;
	}

	if(%client.frozen == 0)
	{
		%client.frozen = 1;
		%client.freezeObject = new StaticShape() 
				{
      					position = %client.player.getTransform();
      					rotation = "1 0 0 0";
      					scale = "0.001 0.001 0.001";
					dataBlock = "flowers";
 				   			};
		%client.freezeObject.setcloaked(true);
		%client.freezeObject.MountObject(%client.player,1);
	}	
	else
	{
		%client.frozen = 0;
		%client.freezeObject.unMountObject(%client.player);
		%client.freezeObject.delete();
	}
}