
//=======================================
//=============iS========================
//=======================================
//Cops n Robbers Spawns are used. The Team that captures ALL conquest points first, wins.

function serverCmdInitConquest(%client)
{
	if(%client.isAdmin || %client.isSuperAdmin)
	{
		if($Pref::Server::GameMode $= 1)
		{
			messageClient(%client,"",'\c3Conquest cannot be initiated because a Game Mode (\c0%1\c3) is already in Progress!',$Pref::Server::GameModeType);
			return;
		}
		if($Pref::Server::Weapons $= 1)
		{
			messageClient(%client,"",'\c3Conquest cannot be initiated because a Game Mode (\c0Deathmatch\c3) is already in Progress!');
			return;			
		}
		$Pref::Server::GameMode = 1;
		$Pref::Server::GameModeType = "Conquest";


		messageAll("","\c5Conquest mode started!");
		for(%t = 0; %t < $Pref::Server::TotalTeams + 1; %t++)
		{
			if($Teams[%t] $= "Humans")
			{
				%HumDone = 1;
				%HumTeamID = %t;
			}
			if($Teams[%t] $= "Goauld")
			{
				%GoaDone = 1;
				%GoaTeamID = %t;
			}

		}
		if(!HumDone)
		{
			serverCmdAddTeam(%client,"Humans");
			%HumTeamID = $Pref::Server::TotalTeams;
			//error(%CopTeamID);
		}
		if(!%GoaDone)
		{
			serverCmdAddTeam(%client,"Goauld");
			%GoaTeamID = $Pref::Server::TotalTeams;
			//error(%RobTeamID);
		}
		$teamSwitch = 1;
		$TotalGoaulds = 0;
		$TotalHumans = 0;
		%time=10;
		for(%t = 0; %t<ClientGroup.getCount(); %t++)
		{
			%cl = ClientGroup.getObject(%t);
			if($teamSwitch $= 0)
			{
				$TotalGoaulds++;
				%cl.Team = "Goauld";
				$teamSwitch = 1;
				bottomPrint(%cl,"\"Conquest\" will be starting in 10 Seconds!!!\nYou will be a GOAULD.\nYour goal is to secure and hold as much ConquestZones as possible.",%time,3);
			}
			else	
			{
				$TotalHumans++;
				%cl.Team = "Humans";
				$teamSwitch = 0;
				bottomPrint(%cl,"\"Conquest\" will be starting in 10 Seconds!!!\nYou will be a HUMAN.\nYour goal is to secure and hold as much ConquestZones as possible.",%time,3);
			}
			
		}
		
		schedule(%time*1000,0,"serverCmdStartConquest",%client);
	
	}
}

function serverCmdStartConquest(%client)
{

	if(%client.isAdmin || %client.isSuperAdmin)
	{
		resetconquestzones();
		$Pref::WeakWindowCount = 0;
		$Pref::Server::Conquest = 1;
		//$Game::RobbersEarnings = 0;
		$Pref::Server::LockTeams = 1;
		serverCmdStartDeathmatch(%client, 0, 0, 0, 0, 0, 1);
		for(%t = 0; %t<ClientGroup.getCount(); %t++)
		{
			
			%cl = ClientGroup.getObject(%t);
			%cl.isImprisoned = 0;
			%cl.money = 0;
			messageClient(%cl,'MsgUpdateMoney',"",%cl.money);
			%cl.player.kill();	

		}
	}
}

function serverCmdEndConquest(%client)
{
	
	if(%client.isAdmin || %client.isSuperAdmin)
	{	
		if($Pref::Server::GameModeType $= "Conquest")
		{
		showstatusc();
		$Pref::Server::GameMode = 0;
		$Pref::Server::GameModeType = "";
		$Pref::Server::Conquest = 0;
		serverCmdEndDeathmatch(%client);
		for(%t = 0; %t<ClientGroup.getCount(); %t++)
		{
			%cl = ClientGroup.getObject(%t);
			%cl.team = "";
			%cl.player.kill();
		}
		resetconquestzones();
		if(false){
		for(%t = 0; %t<MissionCleanup.getCount(); %t++)
		{
			%Window = MissionCleanup.getObject(%t);
			if(%Window.oldPosition !$= "")
			{
				%Window.setTransform(%Window.oldPosition);
			}
		}}
		}
		else
		{
			messageClient(%client,"","\c2A Conquest Game is not in Progress!");
		}
	}
}

function servercmdspawnconquestzone(%client){

%pos=%client.player.getposition();
	if((%client.isAdmin && $Pref::Server::AdminEditor) || %client.isSuperAdmin || %client.isEWandUser)
	{
		%trans = %pos;
		%size="2 2 2";
		%x = getWord(%trans,0)-(getword(%size,0)/2);
		%y = getWord(%trans,1)+(getword(%size,1)/2);
		%z = getWord(%trans,2);
		//%client.SelectedObject.isBaseTrigger = 1;
		//%client.SelectedObject.TriggerSize = %size;

		%b = new Trigger() 
		{
      			position = %x SPC %y SPC %z;
      			rotation = "1 0 0 0";
     			scale = %size;
      			dataBlock = "ConquestZone";
      			polyhedron = "0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
		};
		%b.Conquest=0;
		MissionCleanUp.add(%b);
		
		%b=new staticshape()
		{
            position=vectorsub(%pos,"1.5 1.5 0");
            rotation="1 0 0 0";
            scale="3 3 1";
            datablock=statictile2x2round;
			sg=1;
			isConquestZone=1;
        };
		MissionCleanUp.add(%b);
        %b.setskinname("yellow");
		
		messageClient(%client,'',"\c5Added a ConquestZone");
	}


}
function showstatusc()
{
%h=0;
%g=0;
%all=0;
%total=0;
	for(%t =0; %t < MissionCleanup.getCount(); %t++)
	{
		%brick = MissionCleanup.getObject(%t);
		%a=%brick.conquest;
		if(%a==1||%a==-1||%a==1)
		{
		//echo("jazet"@%brick);
		//echo(%brick.conquest);
		
		%flags[%i]=%brick.Conquest;
		%total=%total+%brick.Conquest;
		//echo("total jetzt"@%total);
		//if(%a $="n"){
			if(%brick.Conquest>0)
				%h++;
			if(%brick.Conquest<0)
				%g++;
			//}
		%i++;
		%all++;
		}
		//if(%fptrue = 0){return;}
	}	
	//echo("Gleichgwe:"@%total);
	%all=5;
	messageAll("","\c4TotalZones: \c4"@%all@"\n\c2Status update:\nGoauld: "@%g@"\nHuman: "@%h);
	if(%h==%all){
		messageAll("","\c1Humans Won!");
		restartconquest();
		}
	if(%g==%all){
		messageAll("","\c1Goauld Won!");
		restartconquest();
		}
		

}
function restartconquest(){
messageAll("","\c1Restarting Conquest!");
resetconquestzones();
commandtoserver('endconquest');
commandtoserver('initconquest');
}


function resetconquestzones()
{
	for(%t =0; %t < MissionCleanup.getCount(); %t++)
	{
		%brick = MissionCleanup.getObject(%t);
		if(!%brick.Conquest == "")
		{
		%brick.Conquest=0;
		}
		//if(%fptrue = 0){return;}
	}	

}

function penis()
{


//function serverCmdSetCopSpawnPoint(%client)


//function serverCmdSetRobberSpawnPoint(%client)

}